<?php if (!defined('PmWiki')) exit();
/**
  EncodePost: Base64 encode/decode fields in posted forms
  Written by (c) Petko Yotov 2023    www.pmwiki.org/petko

  This text is written for PmWiki; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published
  by the Free Software Foundation version 2.
*/
$RecipeInfo['EncodePost']['Version'] = '20230504';

$HTMLHeaderFmt['EncodePost'] =  "<script src='\$FarmPubDirUrl/encodepost.js'></script>";

SDVA($HandleActions, array('encodedpost'=>'HandleEncodedPost'));
SDVA($HandleAuth, array('encodedpost'=>'edit'));

SDVA($InputTags['e_cancelbutton'], array(
  ':html' => "<input type='submit' data-url='\$PageUrl' \$InputFormArgs />"));

# Partially based on HandleEdit() originally by Patrick Michaud
function HandleEncodedPost($pagename, $auth = 'edit') {
  global $IsPagePosted, $EditFields, $ChangeSummary,
    $EnablePost, $FmtV, $Now, $EditRedirectFmt, $EnableRCDiffBytes, 
    $PageEditForm, $HandleEditFmt, $PageStartFmt, $PageEditFmt, $PageEndFmt, $MessagesFmt;
  
  header("Content-Type: application/json");
  
  if(@$_POST['cancel']) {
    $out['redirect'] = PageVar($pagename, '$PageUrl');
    print(pm_json_encode($out));
    exit;
  }
  
  if(!pmtoken(1)) {
    $out = ['failure'=>XL('Token invalid or missing.')];
    print(pm_json_encode($out));
    exit;
  }
  
  Lock(2);
  $page = $new = RetrieveAuthPage($pagename, $auth, true);
  if (!$page) {
    $out = ['failure'=>"Cannot edit $pagename"];
    print(pm_json_encode($out));
    exit;
  }
  
  foreach((array)$EditFields as $k) {
    if (isset($_POST[$k])) {
      $v = str_replace("\r",'',stripmagic($_POST[$k]));
      if(substr($v, 0, 8)==="base64::") $v = base64_decode(substr($v, 8));
      $new[$k] = $v;
    }
  }
  
  $EnablePost &= (bool)preg_grep('/^post/', array_keys(@$_POST));
  $new['=preview'] = @$new['text'];
  PCache($pagename, $new);
  UpdatePage($pagename, $page, $new);
  Lock(0);
    
  ## post - postedit - preview - postdraft?
  $out = [];
  
  if(!$IsPagePosted && !@$_POST['preview']) {
    $out['failure'] = strip_tags(implode("\n", $MessagesFmt));
    print(pm_json_encode($out));
    exit;
  }
  
  $out['success'] = 1;
  $out['n'] = $pagename;
  
  if(@$_POST['preview']) {
    $PagePreviewFmt = "<div id='wikipreview'>
      <h2 class='wikiaction'>$[Preview \$FullName]</h2>
      <p><b>$[Page is unsaved]</b></p>
      \$PreviewText
      <hr /><p><b>$[End of preview -- remember to save]</b><br />
      <a href='#top'>$[Top]</a></p></div>";
  
    $out['preview'] = FmtPageName($PagePreviewFmt, $pagename);
  }
  
  if ($IsPagePosted && !@$_POST['postedit']) 
    $out['redirect'] = PageVar($pagename, '$PageUrl');
  
  if($IsPagePosted) {
    $out['basetime'] = $Now;  
  }
  
  print(pm_json_encode($out));
  exit;
}
